#include <sourcemod>
#include <sdktools>
#pragma newdecls required
#define Plugin_Version "1.9.2 (Final Version)"
#define MSGTAG " \x02[Retakes]\x05"
//////////////////////////////////////////////////////////
//ConVars
ConVar i_nMaxReady = null;
//Booleans
bool IsOnEditMode[MAXPLAYERS+1] = false;
bool IsSpawnTaken[256] = false;
bool IsClientReady[MAXPLAYERS+1] = false;
bool IsMatchLive = false;
bool IsMatchSetup = false;
//Ints
int i_hReadyNum = 0;
//int SpawnNum = 0;
//Strings
char h_iMapName[32];
char h_iPrimaryWeapon[MAXPLAYERS+1][32];
char h_iSecondaryWeapon[MAXPLAYERS+1][32];
char h_iExtraItem[MAXPLAYERS+1][32];
char h_iSideString[4];
//Floats
//////////////////////////////////////////////////////////
public Plugin myinfo = {
	name = "[CS:GO] BlackRocks Retakes",
	author = "noBrain",
	description = "Allow server-side 2vs2 competitve matches",
	version = Plugin_Version,
};

public void OnPluginStart()
{
	//AdminCommands
	RegAdminCmd("sm_emode", Command_EditMode, ADMFLAG_ROOT);
	RegAdminCmd("sm_addspawn", Command_AddSpawn, ADMFLAG_ROOT);
	RegAdminCmd("sm_addbomb", Command_AddBombSpawn, ADMFLAG_ROOT);
	RegAdminCmd("sm_forcestop", Command_ForceStop, ADMFLAG_ROOT);
	//ConosleCommands
	RegConsoleCmd("sm_awp", Command_Awp);
	RegConsoleCmd("sm_ak", Command_Ak);
	RegConsoleCmd("sm_a1", Command_A1);
	RegConsoleCmd("sm_a4", Command_A4);
	RegConsoleCmd("sm_ready", Command_Ready)
	//Hooks
	HookEvent("player_spawn", PlayerSpawn, EventHookMode_PostNoCopy);
	HookEvent("player_team", Event_PlayerTeam);
	HookEvent("round_start", RoundStart);
	HookEvent("player_disconnect", PlayerDisconnect);
	HookEvent("cs_pre_restart", Event_ReRestart);
	//ConVars
	i_nMaxReady = CreateConVar("sm_max_ready_num", "4", "Max ready users needed to startup the match");
	//Extra
	if (!DirExists("cfg/2vs2"))
	{
		CreateDirectory("cfg/2vs2", 511);
	}
}

public void OnMapStart()
{
	for(int client = 1; client <= MaxClients; client++)
	{
		if(IsClientInGame(client))
		{
			IsClientReady[client] = false;
		}
	}
	ConVar g_iConVar = null;
	g_iConVar = FindConVar("mp_warmuptime");
	SetConVarInt(g_iConVar, 99999);
	ServerCommand("mp_warmup_start");
	GetCurrentMap(h_iMapName, sizeof(h_iMapName));
	CMapFile(h_iMapName);
	PrintToServer("%s Map %s settings has been generated.", MSGTAG, h_iMapName);
	IsMatchLive = false;
}

public Action Event_PlayerTeam(Handle event, const char[] name, bool dontBroadcast) 
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	int team = GetEventInt(event, "team");
	if(team == 2)
	{
		Format(h_iPrimaryWeapon[client], sizeof(h_iPrimaryWeapon[]), "weapon_ak47");
		Format(h_iSecondaryWeapon[client], sizeof(h_iSecondaryWeapon[]), "weapon_glock");
	}
	if(team == 3)
	{
		Format(h_iPrimaryWeapon[client], sizeof(h_iPrimaryWeapon[]), "weapon_m4a1");
		Format(h_iSecondaryWeapon[client], sizeof(h_iSecondaryWeapon[]), "weapon_hkp2000");
	}
	if(IsMatchLive)
	{
		if(!IsClientReady[client])
		{
			ChangeClientTeam(client, 1);
			PrintToChat(client, "%s You are not able to join due you are not part of a team.", MSGTAG);
		}
	}
}

public Action PlayerSpawn(Handle event, const char[] name, bool dontBroadcast) 
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	if (GameRules_GetProp("m_bWarmupPeriod") == 1)
	{
		PrintToChat(client, "%s Can't start match while there is a warmup time.", MSGTAG);
		return;
	}
	ApplyWeapons(client);
	CreateTimer(0.1, Timer_SetupSpawn, client);
}

public Action Timer_SetupSpawn(Handle timer, any client)
{
	int SpawnNum = 0;
	char StrSpawnNum[4];
	//ApplyWeapons(client);
	int TeamNum = GetClientTeam(client);
	//GetRandomSide(StrSide);
	//Format(h_iSideString, sizeof(h_iSideString), StrSide);
	ServerCommand("tv_msg \"%s Retakes %s is now on.\"", MSGTAG, h_iSideString);
	if(HasBomb(client))
	{
		if(ApplyBombSpawn(client, h_iSideString, h_iMapName))
		{
			PrintToChat(client, "%s You have spawned on bomb side.", MSGTAG);
		}
		return;
	}
	int MaxTSpawn = GetMaxTeamSpawns(h_iSideString, "T", h_iMapName);
	int MaxCTSpawn = GetMaxTeamSpawns(h_iSideString, "CT", h_iMapName);
	if(TeamNum == 2)
	{
		SpawnNum = GetRandomInt(1, MaxTSpawn);
	}
	else if(TeamNum == 3)
	{
		SpawnNum = GetRandomInt(1, MaxCTSpawn);
	}
	IntToString(SpawnNum, StrSpawnNum, sizeof(StrSpawnNum));
	if(IsClientInGame(client) && IsPlayerAlive(client) && !IsClientSourceTV(client))
	{
		if(IsSpawnTaken[SpawnNum])
		{
			CreateTimer(0.1, Timer_SetupSpawn, client);
		}
		else if(ApplySpawn(client, StrSpawnNum, h_iSideString, h_iMapName))
		{
			IsSpawnTaken[SpawnNum] = true;
			PrintToChat(client, "%s Retake \x0E%s: \x02%d Ts \x05vs \x0B%d CTs.", MSGTAG, h_iSideString, GetTeamPlayers(2), GetTeamPlayers(3));
			PrintToChat(client, "%s You have spawned.", MSGTAG);
		}
		else
		{
			ChangeClientTeam(client, 1);
			PrintToChat(client, "%s not enough spawns have found.", MSGTAG);
		}
	}
}

public Action RoundStart(Handle event, const char[] name, bool dontBroadcast) 
{
	//PrintToChatAll("%s This plugin has been re-created for CsGoBlackRocks 2vs2 matches by \x02noBrain.", MSGTAG);
	//PrintToChatAll("%s Current plugin version: \x02%s", MSGTAG, Plugin_Version);
	if (GameRules_GetProp("m_bWarmupPeriod") == 1)
	{
		IsMatchLive = false;
		for(int client = 1; client <= MaxClients; client++)
		{
			if(IsClientInGame(client))
			{
				IsClientReady[client] = false;
			}
		}
		i_hReadyNum = 0;
		return;
	}
	if(!IsMatchSetup)
	{
		SetupMatch();
		//IsMatchSetup = true;
	}
	char StrSide[4];
	GetRandomSide(StrSide);
	Format(h_iSideString, sizeof(h_iSideString), StrSide);
	RemoveC4();
	int client = GetRandomPlayer(2);
	GivePlayerItem(client, "weapon_c4");
}

public Action PlayerDisconnect(Handle event, const char[] name, bool dontBroadcast) 
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));
	if(IsClientReady[client] && !IsMatchLive)
	{
		i_hReadyNum = i_hReadyNum - 1;
		PrintToChat(client, "%s Current ready players num : %d", MSGTAG, i_hReadyNum);
	}
}

public Action Event_ReRestart(Handle event, const char[] name, bool dontBroadcast) 
{
	for(int spawns = 0; spawns <= 256; spawns++)
	{
		IsSpawnTaken[spawns] = false;
	}
}

public Action Command_Ready(int client, int args)
{
	if(IsClientReady[client])
	{
		PrintToChat(client, "%s You are already marked as ready.", MSGTAG);
		return Plugin_Handled;
	}
	if(IsMatchLive)
	{
		PrintToChat(client, "%s Too late to become as ready!", MSGTAG);
		return Plugin_Handled;
	}
	i_hReadyNum++;
	IsClientReady[client] = true;
	PrintToChat(client, "%s You are now marked as ready.", MSGTAG);
	if(i_hReadyNum == GetConVarInt(i_nMaxReady))
	{
		PrintToChatAll("%s All 4 players are ready, match is going live now.", MSGTAG);
		IsMatchLive = true;
		SetupMatch();
		return Plugin_Handled;
	}
	else
	{
		PrintToChatAll("%s Player %N is ready match will start when all 4 players are ready.", MSGTAG, client);
		return Plugin_Handled;
	}
}

public Action Command_A1(int client, int args)
{
	if(GetClientTeam(client) != 3)
	{
		PrintToChat(client, "%s This command is not available for your team.", MSGTAG);
		return Plugin_Handled;
	}
	Format(h_iPrimaryWeapon[client], sizeof(h_iPrimaryWeapon[]), "weapon_m4a1_silencer");
	PrintToChat(client, "%s You have now selected M4A1 Silencer as a primary weapon.", MSGTAG);
	return Plugin_Handled;
}
public Action Command_A4(int client, int args)
{
	if(GetClientTeam(client) != 3)
	{
		PrintToChat(client, "%s This command is not available for your team.", MSGTAG);
		return Plugin_Handled;
	}
	Format(h_iPrimaryWeapon[client], sizeof(h_iPrimaryWeapon[]), "weapon_m4a1");
	PrintToChat(client, "%s You have now selected M4A4 as a primary weapon.", MSGTAG);
	return Plugin_Handled;
}
public Action Command_Ak(int client, int args)
{
	if(GetClientTeam(client) != 2)
	{
		PrintToChat(client, "%s This command is not available for your team.", MSGTAG);
		return Plugin_Handled;
	}
	Format(h_iPrimaryWeapon[client], sizeof(h_iPrimaryWeapon[]), "weapon_ak47");
	PrintToChat(client, "%s You have now selected AK47 as a primary weapon.", MSGTAG);
	return Plugin_Handled;
}
public Action Command_Awp(int client, int args)
{
	Format(h_iPrimaryWeapon[client], sizeof(h_iPrimaryWeapon[]), "weapon_awp");
	PrintToChat(client, "%s You have now selected AWP as a primary weapon.", MSGTAG);
	return Plugin_Handled;
}
public Action Command_EditMode(int client, int args)
{
	if(args < 1)
	{
		ReplyToCommand(client, "%s Usage: sm_emode 1/0", MSGTAG);
		return Plugin_Handled;
	}
	char StrArgument[32];
	GetCmdArg(1, StrArgument, sizeof(StrArgument));
	if(StrEqual(StrArgument, "1", false))
	{
		if(!IsOnEditMode[client])
		{
			IsOnEditMode[client] = true;
			ReplyToCommand(client, "%s You have entered edit mode.", MSGTAG);
		}
		else
		{
			ReplyToCommand(client, "%s You are already on edit mode.", MSGTAG);
		}
	}
	else if(StrEqual(StrArgument, "0", false))
	{
		if(IsOnEditMode[client])
		{
			IsOnEditMode[client] = false;
			ReplyToCommand(client, "%s You have quited edit mode.", MSGTAG);
		}
		else
		{
			ReplyToCommand(client, "%s You are already out of edit mode.", MSGTAG);
		}
	}
	return Plugin_Handled;
}

public Action Command_AddBombSpawn(int client, int args)
{
	if(args < 1)
	{
		ReplyToCommand(client, "%s Usage: sm_addbomb side, (i.e sm_addbomb A)", MSGTAG);
		return Plugin_Handled;
	}
	if(!IsOnEditMode[client])
	{
		ReplyToCommand(client, "%s You are not on edit mode, please enable edit mode first.", MSGTAG);
		return Plugin_Handled;
	}
	char StrSide[4], StrPath[64];
	Format(StrPath, sizeof(StrPath), "cfg/2vs2/%s.cfg", h_iMapName);
	GetCmdArg(1, StrSide, sizeof(StrSide));
	Handle kv = CreateKeyValues("spawns");
	FileToKeyValues(kv, StrPath);
	if(StrEqual(StrSide, "A", false))
	{
		if(KvJumpToKey(kv, "A", true))
		{
			float Origin[3];
			GetClientAbsOrigin(client, Origin);
			KvSetFloat(kv, "Pitch", Origin[0]);
			KvSetFloat(kv, "Yaw", Origin[1]);
			KvSetFloat(kv, "Roll", Origin[2]);
			ReplyToCommand(client, "%s Bomb Side A Location (%f , %f , %f) has been saved.", MSGTAG, Origin[0], Origin[1], Origin[2]);
			KvRewind(kv);
			KeyValuesToFile(kv, StrPath);
			CloseHandle(kv);
			return Plugin_Handled;
		}
	}
	else if(StrEqual(StrSide, "B", false))
	{
		if(KvJumpToKey(kv, "B", true))
		{
			float Origin[3];
			GetClientAbsOrigin(client, Origin);
			KvSetFloat(kv, "Pitch", Origin[0]);
			KvSetFloat(kv, "Yaw", Origin[1]);
			KvSetFloat(kv, "Roll", Origin[2]);
			ReplyToCommand(client, "%s Bomb Side B Location (%f , %f , %f) has been saved.", MSGTAG, Origin[0], Origin[1], Origin[2]);
			KvRewind(kv);
			KeyValuesToFile(kv, StrPath);
			CloseHandle(kv);
			return Plugin_Handled;
		}
	}
	return Plugin_Handled;
}

public Action Command_AddSpawn(int client, int args)
{
	if(args < 3)
	{
		ReplyToCommand(client, "%s Usage: sm_addspawn side team num (i.e sm_addspawn B CT 1)", MSGTAG);
		return Plugin_Handled;
	}
	if(!IsOnEditMode[client])
	{
		ReplyToCommand(client, "%s You are not on edit mode, please enable edit mode first.", MSGTAG);
		return Plugin_Handled;
	}
	char StrSide[4], StrTeam[4], StrSpawnNumb[4], StrPath[64];
	Format(StrPath, sizeof(StrPath), "cfg/2vs2/%s.cfg", h_iMapName);
	GetCmdArg(1, StrSide, sizeof(StrSide));
	GetCmdArg(2, StrTeam, sizeof(StrTeam));
	GetCmdArg(3, StrSpawnNumb, sizeof(StrSpawnNumb));
	Handle kv = CreateKeyValues("spawns");
	FileToKeyValues(kv, StrPath);
	if(StrEqual(StrSide, "A", false))
	{
		if(KvJumpToKey(kv, "A", true))
		{
			if(StrEqual(StrTeam, "CT", false))
			{
				if(KvJumpToKey(kv, "CT", true))
				{
					if(KvJumpToKey(kv, StrSpawnNumb, true))
					{
						float Origin[3];
						GetClientAbsOrigin(client, Origin);
						KvSetFloat(kv, "Pitch", Origin[0]);
						KvSetFloat(kv, "Yaw", Origin[1]);
						KvSetFloat(kv, "Roll", Origin[2]);
						ReplyToCommand(client, "%s Location (%f , %f , %f) has been saved.", MSGTAG, Origin[0], Origin[1], Origin[2]);
						KvRewind(kv);
						KeyValuesToFile(kv, StrPath);
						CloseHandle(kv);
						return Plugin_Handled;
					}
					else
					{
						ReplyToCommand(client, "%s An error ocurred. (error code: 1)", MSGTAG);
						return Plugin_Handled;
					}
				}
				else
				{
					ReplyToCommand(client, "%s An error ocurred. (error code: 2)", MSGTAG);
					return Plugin_Handled;
				}
			}
			else if(StrEqual(StrTeam, "T", false))
			{
				if(KvJumpToKey(kv, "T", true))
				{
					if(KvJumpToKey(kv, StrSpawnNumb, true))
					{
						float Origin[3];
						GetClientAbsOrigin(client, Origin);
						KvSetFloat(kv, "Pitch", Origin[0]);
						KvSetFloat(kv, "Yaw", Origin[1]);
						KvSetFloat(kv, "Roll", Origin[2]);
						ReplyToCommand(client, "%s Location (%f , %f , %f) has been saved.", MSGTAG, Origin[0], Origin[1], Origin[2]);
						KvRewind(kv);
						KeyValuesToFile(kv, StrPath);
						CloseHandle(kv);
						return Plugin_Handled;
					}
					else
					{
						ReplyToCommand(client, "%s An error ocurred. (error code: 3)", MSGTAG);
						return Plugin_Handled;
					}
				}
				else
				{
					ReplyToCommand(client, "%s An error ocurred. (error code: 4)", MSGTAG);
					return Plugin_Handled;
				}
			}
		}
		else
		{
			ReplyToCommand(client, "%s An error ocurred. (error code: 5)", MSGTAG);
			return Plugin_Handled;
		}
	}
	else if(StrEqual(StrSide, "B", false))
	{
		if(KvJumpToKey(kv, "B", true))
		{
			if(StrEqual(StrTeam, "CT", false))
			{
				if(KvJumpToKey(kv, "CT", true))
				{
					if(KvJumpToKey(kv, StrSpawnNumb, true))
					{
						float Origin[3];
						GetClientAbsOrigin(client, Origin);
						KvSetFloat(kv, "Pitch", Origin[0]);
						KvSetFloat(kv, "Yaw", Origin[1]);
						KvSetFloat(kv, "Roll", Origin[2]);
						ReplyToCommand(client, "%s Location (%f , %f , %f) has been saved.", MSGTAG, Origin[0], Origin[1], Origin[2]);
						KvRewind(kv);
						KeyValuesToFile(kv, StrPath);
						CloseHandle(kv);
						return Plugin_Handled;
					}
					else
					{
						ReplyToCommand(client, "%s An error ocurred. (error code: 6)", MSGTAG);
						return Plugin_Handled;
					}
				}
				else
				{
					ReplyToCommand(client, "%s An error ocurred. (error code: 7)", MSGTAG);
					return Plugin_Handled;
				}
			}
			else if(StrEqual(StrTeam, "T", false))
			{
				if(KvJumpToKey(kv, "T", true))
				{
					if(KvJumpToKey(kv, StrSpawnNumb, true))
					{
						float Origin[3];
						GetClientAbsOrigin(client, Origin);
						KvSetFloat(kv, "Pitch", Origin[0]);
						KvSetFloat(kv, "Yaw", Origin[1]);
						KvSetFloat(kv, "Roll", Origin[2]);
						ReplyToCommand(client, "%s Location (%f , %f , %f) has been saved.", MSGTAG, Origin[0], Origin[1], Origin[2]);
						KvRewind(kv);
						KeyValuesToFile(kv, StrPath);
						CloseHandle(kv);
						return Plugin_Handled;
					}
					else
					{
						ReplyToCommand(client, "%s An error ocurred. (error code: 8)", MSGTAG);
						return Plugin_Handled;
					}
				}
				else
				{
					ReplyToCommand(client, "%s An error ocurred. (error code: 9)", MSGTAG);
					return Plugin_Handled;
				}
			}
		}
		else
		{
			ReplyToCommand(client, "%s An error ocurred. (error code: 10)", MSGTAG);
			return Plugin_Handled;
		}
	}
	return Plugin_Handled;
}

public Action Command_ForceStop(int client, int args)
{
	if(!IsMatchLive)
	{
		ReplyToCommand(client, "%s You cannot force stop due the match is not currently live", MSGTAG);
		return Plugin_Handled;
	}
	IsMatchLive = false;
	IsMatchSetup = false;
	i_hReadyNum = 0;
	for(int user = 1; user <= MaxClients; user++)
	{
		if(IsClientInGame(user))
		{
			IsClientReady[user] = false;
		}
	}
	ServerCommand("mp_warmup_start");
	PrintToChatAll("%s Match force stopped.", MSGTAG);
	return Plugin_Handled;
}

bool CMapFile(char[] StrMapName)
{
	char StrPath[128];
	Format(StrPath, sizeof(StrPath), "cfg/2vs2/%s.cfg", StrMapName);
	if(FileExists(StrPath))
	{
		return false;
	}
	Handle kv = CreateKeyValues("spawns");
	KeyValuesToFile(kv, StrPath);
	CloseHandle(kv);
	return true;
}
bool ApplySpawn(int client, char[] StrSpawnNumb, char[] StrSide, char[] StrMapName)
{
	char StrPath[128];
	Format(StrPath, sizeof(StrPath), "cfg/2vs2/%s.cfg", StrMapName);
	if(!FileExists(StrPath))
	{
		return false;
	}
	Handle kv = CreateKeyValues("spawns");
	FileToKeyValues(kv, StrPath);
	if(KvJumpToKey(kv, StrSide, false))
	{
		int i_hTeam = GetClientTeam(client);
		if(i_hTeam == 2)
		{
			if(KvJumpToKey(kv, "T", false))
			{
				if(KvJumpToKey(kv, StrSpawnNumb, false))
				{
					float Origin[3];
					Origin[0] = KvGetFloat(kv, "Pitch");
					Origin[1] = KvGetFloat(kv, "Yaw");
					Origin[2] = KvGetFloat(kv, "Roll");
					TeleportEntity(client, Origin, NULL_VECTOR, NULL_VECTOR);
					return true;
				}
				else
				{
					PrintToServer("&s Spawn was not found.", MSGTAG);
					return false;
				}
			}
		}
		else if(i_hTeam == 3)
		{
			if(KvJumpToKey(kv, "CT", false))
			{
				if(KvJumpToKey(kv, StrSpawnNumb, false))
				{
					float Origin[3];
					Origin[0] = KvGetFloat(kv, "Pitch");
					Origin[1] = KvGetFloat(kv, "Yaw");
					Origin[2] = KvGetFloat(kv, "Roll");
					TeleportEntity(client, Origin, NULL_VECTOR, NULL_VECTOR);
					return true;
				}
				else
				{
					PrintToServer("&s Spawn was not found.", MSGTAG);
					return false;
				}
			}
		}
	}
	return false;
}

bool ApplyBombSpawn(int client, char[] StrSide, char[] StrMapName)
{
	char StrPath[128];
	Format(StrPath, sizeof(StrPath), "cfg/2vs2/%s.cfg", StrMapName);
	if(!FileExists(StrPath))
	{
		return false;
	}
	Handle kv = CreateKeyValues("spawns");
	FileToKeyValues(kv, StrPath);
	if(KvJumpToKey(kv, StrSide, false))
	{
		float Origin[3];
		Origin[0] = KvGetFloat(kv, "Pitch");
		Origin[1] = KvGetFloat(kv, "Yaw");
		Origin[2] = KvGetFloat(kv, "Roll");
		TeleportEntity(client, Origin, NULL_VECTOR, NULL_VECTOR);
		CloseHandle(kv);
		return true;
	}
	else
	{
		PrintToServer("&s Spawn was not found.", MSGTAG);
		CloseHandle(kv)
		return false;
	}
}
 
void GetRandomSide(char StrSide[4])
{
	int Side = GetRandomInt(0, 1);
	if(Side == 0)
	{
		Format(StrSide, sizeof(StrSide), "A");
	}
	else if(Side == 1)
	{
		Format(StrSide, sizeof(StrSide), "B");
	}
}

int GetMaxTeamSpawns(char[] StrSide, char[] StrTeam, char[] StrMapName)
{
	char StrPath[128];
	int g_iMaxSpawns;
	Format(StrPath, sizeof(StrPath), "cfg/2vs2/%s.cfg", StrMapName);
	Handle kv = CreateKeyValues("spawns");
	FileToKeyValues(kv, StrPath);
	if(KvJumpToKey(kv, StrSide, false))
	{
		if(KvJumpToKey(kv, StrTeam, false))
		{
			KvGotoFirstSubKey(kv, false)
			do
			{
				g_iMaxSpawns++;
			}
			while(KvGotoNextKey(kv, false));
		}
	}
	CloseHandle(kv);
	return g_iMaxSpawns;
}

void ApplyWeapons(int client)
{
	GetRandomGen(client);
	StripAllWeapons(client);
	GivePlayerItem(client, h_iPrimaryWeapon[client]);
	GivePlayerItem(client, h_iSecondaryWeapon[client]);
	GivePlayerItem(client, "weapon_knife");
	GivePlayerItem(client, h_iExtraItem[client]);
}

void StripAllWeapons(int client) 
{

	if (client < 1 || client > MaxClients || !IsClientInGame(client)) {

		return;

	}

	int weapon;
	for (int i; i < 4; i++) {
	
		if ((weapon = GetPlayerWeaponSlot(client, i)) != -1) {
		
			if (IsValidEntity(weapon)) {
			
				RemovePlayerItem(client, weapon);
				AcceptEntityInput(weapon, "Kill");
				
			}
			
		}
		
	}
	
}

void GetRandomGen(int client)
{
	int GenNum = GetRandomInt(1, 4);
	if(GenNum == 1)
	{
		Format(h_iExtraItem[client], sizeof(h_iExtraItem[]), "weapon_molotov");
	}
	else if(GenNum == 2)
	{
		Format(h_iExtraItem[client], sizeof(h_iExtraItem[]), "weapon_hegrenade");
	}
	else if(GenNum == 3)
	{
		Format(h_iExtraItem[client], sizeof(h_iExtraItem[]), "weapon_smokegrenade");
	}
	else if(GenNum == 4)
	{
		Format(h_iExtraItem[client], sizeof(h_iExtraItem[]), "weapon_flashbang");
	}
}


public int GetRandomPlayer(int team)
{
    int RandomClient;

    ArrayList ValidClients = new ArrayList();
    
    for(int i = 1; i < MaxClients; i++)
    {
        if(IsValidClient(i) && GetClientTeam(i) == team)
        {
            ValidClients.Push(i);
        }
    }
    
    RandomClient = ValidClients.Get(GetRandomInt(0, ValidClients.Length - 1));
    
    delete ValidClients;
  
    return RandomClient;
}

stock bool IsValidClient(int client) 
{ 
    return (1 <= client <= MaxClients && IsClientInGame(client) && !IsClientSourceTV(client)); 
} 

bool HasBomb(int client)
{
	char WeaponName[32];
	if(IsClientInGame(client) && IsPlayerAlive(client))
	{
		for(int slot = 0; slot <= 4; slot++)
		{
			int ent = GetPlayerWeaponSlot(client, slot);
			if(ent != -1)
			{
				if (IsValidEntity(ent))
				{
					GetEdictClassname(ent, WeaponName, sizeof(WeaponName));
					if(StrEqual(WeaponName, "weapon_c4"))
					{
						return true;
					}
				}
			}
		}
	}
	return false;
}

stock void RemoveC4()
{
	char WeaponName[32];
	for(int i = 1; i <= MaxClients; i++)
	{
		if(IsClientInGame(i) && IsPlayerAlive(i))
		{
			for(int slot = 0; slot <= 4; slot++)
			{
				int ent = GetPlayerWeaponSlot(i, slot);
				if(ent != -1)
				{
					if (IsValidEntity(ent))
					{
						GetEdictClassname(ent, WeaponName, sizeof(WeaponName));
						if(StrEqual(WeaponName, "weapon_c4"))
						{
							RemovePlayerItem(i, ent);
							AcceptEntityInput(ent, "Kill");
							
						}
					}
				}
			}
		}
	}
}
stock int GetTeamPlayers(int team)
{
	int i_gUserNum = 0;
	for(int user = 1; user <= MaxClients ; user++)
	{
		if(IsClientConnected(user) && IsPlayerAlive(user) && GetClientTeam(user) == team)
		{
			i_gUserNum++;
		}
	}
	return i_gUserNum;
}

stock void SetupMatch()
{
	if(!IsMatchSetup)
	{
		ServerCommand("mp_warmup_end");
		IsMatchSetup = true;
	}
	CreateTimer(0.5, Timer_RestartMatch);
}

public Action Timer_RestartMatch(Handle timer)
{
	for(int i = 1;i<=MaxClients;i++)
	{
		if(IsClientInGame(i) && IsPlayerAlive(i) && !IsClientReady[i])
		{
			ChangeClientTeam(i, 1);
			PrintToChat(i, "%s You have been moved to spect cause you are not part of the match.");
		}
	}
	ServerCommand("mp_restartgame 1");
	char CfgPath[64] = "2vs2/2vs2.cfg";
	ServerCommand("exec %s", CfgPath);
	PrintToChatAll("%s Match is live now.", MSGTAG)
}